


<h1><a name="haskell" id="haskell">Haskell</a></h1>
<div class="level1">

<p>

<a href="http://www.haskell.org/" class="urlextern" title="http://www.haskell.org/"  rel="nofollow">Haskell</a>: <a href="http://en.wikipedia.org/wiki/Haskell_(programming_language)" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Haskell_(programming_language)">Haskell</a>
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Haskell" [1-107] -->
<h2><a name="haskell_instalation" id="haskell_instalation">Haskell Instalation</a></h2>
<div class="level2">
<pre class="code bash">$ <span class="kw2">sudo</span> <span class="kw2">apt-get</span> <span class="kw2">install</span> ghc6 libghc6-mtl-dev
$ <span class="kw2">sudo</span> port <span class="kw2">install</span> ghc</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Haskell Instalation" [108-229] -->
<h2><a name="haskell_libraries" id="haskell_libraries">Haskell Libraries</a></h2>
<div class="level2">

<p>

<a href="http://www.haskell.org/ghc/docs/6.12.2/html/libraries/" class="urlextern" title="http://www.haskell.org/ghc/docs/6.12.2/html/libraries/"  rel="nofollow">Haskell Hierarchical Libraries</a>
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Haskell Libraries" [230-351] -->
<h2><a name="haskell_tutorials" id="haskell_tutorials">Haskell Tutorials</a></h2>
<div class="level2">

<p>

<a href="http://learnyouahaskell.com/" class="urlextern" title="http://learnyouahaskell.com/"  rel="nofollow">Learn You a Haskell for Great Good</a> <br/>

<a href="http://book.realworldhaskell.org/read/" class="urlextern" title="http://book.realworldhaskell.org/read/"  rel="nofollow">Real World Haskell</a> <br/>

</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Haskell Tutorials" [352-519] -->
<h2><a name="how_to_search_for_a_haskell_function" id="how_to_search_for_a_haskell_function">How to Search for a Haskell Function</a></h2>
<div class="level2">

<p>

<a href="http://haskell.org/hoogle/" class="urlextern" title="http://haskell.org/hoogle/"  rel="nofollow">Hoogle</a> - Haskell <acronym title="Application Programming Interface">API</acronym> search engine
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to Search for a Haskell Function" [520-636] -->
<h2><a name="haskell_cheat_sheet" id="haskell_cheat_sheet">Haskell Cheat Sheet</a></h2>
<div class="level2">

<p>

Inspired on the first tutorial in the list.
</p>
<pre class="code bash"><span class="co0"># start the interpreter</span>
$ ghci</pre>
<pre class="code haskell">:l myfunctions <span class="co1">--load the functions in the file myfunctions.hs</span>
:r             <span class="co1">--reload</span>
&nbsp;
<span class="nu0">1</span> <span class="sy0">/=</span> <span class="nu0">0</span>         <span class="co1">--not equal</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:succ"><span class="kw3">succ</span></a> <span class="nu0">0</span> <span class="sy0">==</span> <span class="nu0">1</span>    <span class="co1">--successor</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:min"><span class="kw3">min</span></a> <span class="nu0">1</span> <span class="nu0">2</span> <span class="sy0">==</span> <span class="nu0">1</span>   <span class="co1">--minimum</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:max"><span class="kw3">max</span></a> <span class="nu0">1</span> <span class="nu0">2</span> <span class="sy0">==</span> <span class="nu0">2</span>   <span class="co1">--maximum</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:div"><span class="kw3">div</span></a> 2 1 <span class="sy0">==</span> 2 `<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:div"><span class="kw3">div</span></a>` <span class="nu0">1</span> <span class="co1">--infix notation</span>
mysucc x <span class="sy0">=</span> x <span class="sy0">+</span> <span class="nu0">1</span>     <span class="co1">--function definition</span>
&nbsp;
<span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="nu0">1</span>:<span class="nu0">2</span>:<span class="br0">&#91;</span><span class="br0">&#93;</span>     <span class="co1">--list definition</span>
<span class="st0">&quot;ab&quot;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'b'<span class="br0">&#93;</span>   <span class="co1">--string is [Char]</span>
<span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="br0">&#93;</span> <span class="sy0">++</span> <span class="br0">&#91;</span><span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">4</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">4</span><span class="br0">&#93;</span> <span class="co1">--list concatenation</span>
<span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'b'<span class="br0">&#93;</span> <span class="sy0">!!</span> <span class="nu0">1</span> <span class="sy0">==</span> 'b'           <span class="co1">--list indexing</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> 1
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:tail"><span class="kw3">tail</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>2<span class="sy0">,</span> 3<span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:init"><span class="kw3">init</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:last"><span class="kw3">last</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> 3
l <span class="sy0">==</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a> l<span class="br0">&#41;</span>:<span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:tail"><span class="kw3">tail</span></a> l<span class="br0">&#41;</span> <span class="sy0">==</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:init"><span class="kw3">init</span></a> l<span class="br0">&#41;</span> <span class="sy0">++</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:last"><span class="kw3">last</span></a> l<span class="br0">&#41;</span>
&nbsp;
lenght <span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'b'<span class="br0">&#93;</span> <span class="sy0">==</span> 2
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:null"><span class="kw3">null</span></a> <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">==</span> True                  <span class="co1">--list is empty?</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:reverse"><span class="kw3">reverse</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>3<span class="sy0">,</span> 2<span class="sy0">,</span> 1<span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:take"><span class="kw3">take</span></a> <span class="nu0">2</span> <span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'b'<span class="sy0">,</span> 'c'<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'b'<span class="br0">&#93;</span> <span class="co1">--first n elements of list</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:drop"><span class="kw3">drop</span></a> <span class="nu0">2</span> <span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'b'<span class="sy0">,</span> 'c'<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>'c'<span class="br0">&#93;</span>      <span class="co1">--drops n elements of list</span>
l <span class="sy0">==</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:take"><span class="kw3">take</span></a> n l<span class="br0">&#41;</span> <span class="sy0">++</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:drop"><span class="kw3">drop</span></a> n l<span class="br0">&#41;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:maximum"><span class="kw3">maximum</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> 3
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:minimum"><span class="kw3">minimum</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> 1
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:sum"><span class="kw3">sum</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 4<span class="br0">&#93;</span> <span class="sy0">==</span> 10
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:product"><span class="kw3">product</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 4<span class="br0">&#93;</span> <span class="sy0">==</span> 24
2 `<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:elem"><span class="kw3">elem</span></a>` <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span> <span class="sy0">==</span> True       <span class="co1">--element of the list?</span>
&nbsp;
<span class="br0">&#91;</span>1<span class="sy0">..</span>3<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span>
<span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> 3<span class="sy0">..</span>10<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">5</span><span class="sy0">,</span> <span class="nu0">7</span><span class="sy0">,</span> <span class="nu0">9</span><span class="br0">&#93;</span>
<span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> 3<span class="sy0">..</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> 5<span class="sy0">..</span><span class="br0">&#93;</span>          <span class="co1">--infinite list</span>
factorial n <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:product"><span class="kw3">product</span></a> <span class="br0">&#91;</span>1<span class="sy0">..</span>n<span class="br0">&#93;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:take"><span class="kw3">take</span></a> <span class="nu0">24</span> <span class="br0">&#91;</span><span class="nu0">13</span><span class="sy0">,</span> 26<span class="sy0">..</span><span class="br0">&#93;</span>               <span class="co1">--the first 24 multiples of 13</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:take"><span class="kw3">take</span></a> 7 <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:cycle"><span class="kw3">cycle</span></a> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span><span class="br0">&#41;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">1</span><span class="br0">&#93;</span> <span class="co1">--cycle creates an infinite list</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:take"><span class="kw3">take</span></a> 3 <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:repeat"><span class="kw3">repeat</span></a> 'a'<span class="br0">&#41;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'a'<span class="sy0">,</span> 'a'<span class="br0">&#93;</span>            <span class="co1">--repeat creates an infinite list</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:take"><span class="kw3">take</span></a> n <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:repeat"><span class="kw3">repeat</span></a> x<span class="br0">&#41;</span> <span class="sy0">==</span> replicate n x
&nbsp;
<span class="br0">&#91;</span>x <span class="sy0">*</span> 2 <span class="sy0">|</span> x <span class="sy0">&lt;-</span> <span class="br0">&#91;</span>1 <span class="sy0">..</span> 10<span class="br0">&#93;</span><span class="sy0">,</span> 3 <span class="sy0">*</span> x <span class="sy0">&lt;</span> 7<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>2<span class="sy0">,</span> 4<span class="br0">&#93;</span>
<span class="br0">&#91;</span> x<span class="sy0">*</span>y <span class="sy0">|</span> x <span class="sy0">&lt;-</span> <span class="br0">&#91;</span>2<span class="sy0">,</span>5<span class="sy0">,</span>10<span class="br0">&#93;</span><span class="sy0">,</span> y <span class="sy0">&lt;-</span> <span class="br0">&#91;</span>8<span class="sy0">,</span>10<span class="sy0">,</span>11<span class="br0">&#93;</span><span class="sy0">,</span> x<span class="sy0">*</span>y <span class="sy0">&gt;</span> 50<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>55<span class="sy0">,</span>80<span class="sy0">,</span>100<span class="sy0">,</span>110<span class="br0">&#93;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:length"><span class="kw3">length</span></a>' xs <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:sum"><span class="kw3">sum</span></a> <span class="br0">&#91;</span>1 <span class="sy0">|</span> <span class="sy0">_</span> <span class="sy0">&lt;-</span> xs<span class="br0">&#93;</span>
removeNonUppercase st <span class="sy0">=</span> <span class="br0">&#91;</span> c <span class="sy0">|</span> c <span class="sy0">&lt;-</span> st<span class="sy0">,</span> c `<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:elem"><span class="kw3">elem</span></a>` <span class="br0">&#91;</span>'A'<span class="sy0">..</span>'Z'<span class="br0">&#93;</span><span class="br0">&#93;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:fst"><span class="kw3">fst</span></a> <span class="br0">&#40;</span>1<span class="sy0">,</span> 'a'<span class="br0">&#41;</span> <span class="sy0">==</span> 1
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:snd"><span class="kw3">snd</span></a> <span class="br0">&#40;</span>1<span class="sy0">,</span> 'a'<span class="br0">&#41;</span> <span class="sy0">==</span> 'a'
<span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:fst"><span class="kw3">fst</span></a> x<span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:snd"><span class="kw3">snd</span></a> x<span class="br0">&#41;</span> <span class="sy0">==</span> x
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zip"><span class="kw3">zip</span></a> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="br0">&#93;</span> <span class="br0">&#91;</span>'a'<span class="sy0">,</span> 'b'<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="br0">&#40;</span><span class="nu0">1</span><span class="sy0">,</span> 'a'<span class="br0">&#41;</span><span class="sy0">,</span> <span class="br0">&#40;</span><span class="nu0">2</span><span class="sy0">,</span> 'b'<span class="br0">&#41;</span><span class="br0">&#93;</span>
:t <span class="st0">&quot;HI&quot;</span> <span class="sy0">==</span> <span class="st0">&quot;HI&quot;</span> <span class="sy0">::</span> <span class="br0">&#91;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Char"><span class="kw4">Char</span></a><span class="br0">&#93;</span>                         <span class="co1">--type</span>
removeNonUppercase <span class="sy0">::</span> <span class="br0">&#91;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Char"><span class="kw4">Char</span></a><span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Char"><span class="kw4">Char</span></a><span class="br0">&#93;</span>            <span class="co1">--function type declaration</span>
:t <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a> <span class="sy0">==</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a> <span class="sy0">::</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> a                       <span class="co1">--type variable &quot;a&quot;</span>
:t <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:elem"><span class="kw3">elem</span></a> <span class="sy0">==</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:elem"><span class="kw3">elem</span></a> <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Eq"><span class="kw4">Eq</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> a <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Bool"><span class="kw4">Bool</span></a>     <span class="co1">--type class &quot;Eq&quot;</span>
&nbsp;
5 `<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:compare"><span class="kw3">compare</span></a>` 3 <span class="sy0">==</span> GT
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:show"><span class="kw3">show</span></a> <span class="nu0">5.334</span> <span class="sy0">==</span> <span class="st0">&quot;5.334&quot;</span>                             <span class="co1">--to string</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:read"><span class="kw3">read</span></a> <span class="st0">&quot;[1, 2, 3]&quot;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span>                     <span class="co1">--from string</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:read"><span class="kw3">read</span></a> <span class="st0">&quot;5&quot;</span> <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a>                                 <span class="co1">--type anotation</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:minBound"><span class="kw3">minBound</span></a> <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Int"><span class="kw4">Int</span></a> <span class="sy0">==</span> <span class="sy0">-</span>2147483648
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:maxBound"><span class="kw3">maxBound</span></a> <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Int"><span class="kw4">Int</span></a> <span class="sy0">==</span> 2147483647
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:fromIntegral"><span class="kw3">fromIntegral</span></a> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:length"><span class="kw3">length</span></a> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span><span class="nu0">2</span><span class="sy0">,</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">4</span><span class="br0">&#93;</span><span class="br0">&#41;</span> <span class="sy0">+</span> <span class="nu0">3.2</span> <span class="sy0">==</span> <span class="nu0">7.2</span>      <span class="co1">--integral to float</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a>' <span class="sy0">::</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> a  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a>' <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:error"><span class="kw3">error</span></a> <span class="st0">&quot;Can't call head on an empty list, dummy!&quot;</span>  <span class="co1">--run-time error</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a>' <span class="br0">&#40;</span>x:<span class="sy0">_</span><span class="br0">&#41;</span> <span class="sy0">=</span> x  
&nbsp;
capital <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a> <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a>  
capital <span class="st0">&quot;&quot;</span> <span class="sy0">=</span> <span class="st0">&quot;Empty string, whoops!&quot;</span>  
capital <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:all"><span class="kw3">all</span></a><span class="sy0">@</span><span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span> <span class="sy0">=</span> <span class="st0">&quot;The first letter of &quot;</span> <span class="sy0">++</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:all"><span class="kw3">all</span></a> <span class="sy0">++</span> <span class="st0">&quot; is &quot;</span> <span class="sy0">++</span> <span class="br0">&#91;</span>x<span class="br0">&#93;</span> <span class="co1">--as pattern</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:max"><span class="kw3">max</span></a>' <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Ord"><span class="kw4">Ord</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> a <span class="sy0">-&gt;</span> a <span class="sy0">-&gt;</span> a  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:max"><span class="kw3">max</span></a>' a b   
  <span class="sy0">|</span> a <span class="sy0">&gt;</span> b     <span class="sy0">=</span> a  <span class="co1">--guard</span>
  <span class="sy0">|</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:otherwise"><span class="kw3">otherwise</span></a> <span class="sy0">=</span> b  <span class="co1">--otherwise = True</span>
&nbsp;
bmiTell <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:RealFloat"><span class="kw4">RealFloat</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> a <span class="sy0">-&gt;</span> a <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a>  
bmiTell weight height  
  <span class="sy0">|</span> bmi <span class="sy0">&lt;=</span> skinny <span class="sy0">=</span> <span class="st0">&quot;You're underweight, you emo, you!&quot;</span>  
  <span class="sy0">|</span> bmi <span class="sy0">&lt;=</span> normal <span class="sy0">=</span> <span class="st0">&quot;You're supposedly normal. Pffft, I bet you're ugly!&quot;</span>  
  <span class="sy0">|</span> bmi <span class="sy0">&lt;=</span> fat    <span class="sy0">=</span> <span class="st0">&quot;You're fat! Lose some weight, fatty!&quot;</span>  
  <span class="sy0">|</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:otherwise"><span class="kw3">otherwise</span></a>     <span class="sy0">=</span> <span class="st0">&quot;You're a whale, congratulations!&quot;</span>
  <span class="kw1">where</span> bmi <span class="sy0">=</span> weight <span class="sy0">/</span> height <span class="sy0">^</span> 2  
        <span class="br0">&#40;</span>skinny<span class="sy0">,</span> normal<span class="sy0">,</span> fat<span class="br0">&#41;</span> <span class="sy0">=</span> <span class="br0">&#40;</span>18<span class="sy0">.</span>5<span class="sy0">,</span> 25<span class="sy0">.</span>0<span class="sy0">,</span> 30<span class="sy0">.</span>0<span class="br0">&#41;</span>  
&nbsp;
cylinderSurfaceArea <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:RealFloat"><span class="kw4">RealFloat</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> a <span class="sy0">-&gt;</span> a <span class="sy0">-&gt;</span> a  
cylinderSurfaceArea r h <span class="sy0">=</span> 
  <span class="kw1">let</span> sideArea <span class="sy0">=</span> 2 <span class="sy0">*</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:pi"><span class="kw3">pi</span></a> <span class="sy0">*</span> r <span class="sy0">*</span> h  
      topArea <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:pi"><span class="kw3">pi</span></a> <span class="sy0">*</span> r <span class="sy0">^</span> 2  
  <span class="kw1">in</span>  sideArea <span class="sy0">+</span> 2 <span class="sy0">*</span> topArea   
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a>' <span class="sy0">::</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> a
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:head"><span class="kw3">head</span></a>' xs <span class="sy0">=</span> <span class="kw1">case</span> xs <span class="kw1">of</span> <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:error"><span class="kw3">error</span></a> <span class="st0">&quot;No head for empty lists!&quot;</span>
                      <span class="br0">&#40;</span>x:<span class="sy0">_</span><span class="br0">&#41;</span> <span class="sy0">-&gt;</span> x
&nbsp;
quicksort <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Ord"><span class="kw4">Ord</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span>  
quicksort <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#91;</span><span class="br0">&#93;</span>  
quicksort <span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span> <span class="sy0">=</span>   
  <span class="kw1">let</span> smallerSorted <span class="sy0">=</span> quicksort <span class="br0">&#91;</span>a <span class="sy0">|</span> a <span class="sy0">&lt;-</span> xs<span class="sy0">,</span> a <span class="sy0">&lt;=</span> x<span class="br0">&#93;</span>  
      biggerSorted <span class="sy0">=</span> quicksort <span class="br0">&#91;</span>a <span class="sy0">|</span> a <span class="sy0">&lt;-</span> xs<span class="sy0">,</span> a <span class="sy0">&gt;</span> x<span class="br0">&#93;</span>  
  <span class="kw1">in</span>  smallerSorted <span class="sy0">++</span> <span class="br0">&#91;</span>x<span class="br0">&#93;</span> <span class="sy0">++</span> biggerSorted
&nbsp;
divideByTen <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Floating"><span class="kw4">Floating</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> a <span class="sy0">-&gt;</span> a  
divideByTen <span class="sy0">=</span> <span class="br0">&#40;</span><span class="sy0">/</span><span class="nu0">10</span><span class="br0">&#41;</span>                    <span class="co1">--section, infix function partial application</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith"><span class="kw3">zipWith</span></a>' <span class="sy0">::</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> b <span class="sy0">-&gt;</span> c<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>b<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>c<span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith"><span class="kw3">zipWith</span></a>' <span class="sy0">_</span> <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">_</span> <span class="sy0">=</span> <span class="br0">&#91;</span><span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith"><span class="kw3">zipWith</span></a>' <span class="sy0">_</span> <span class="sy0">_</span> <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#91;</span><span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith"><span class="kw3">zipWith</span></a>' f <span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span> <span class="br0">&#40;</span>y:ys<span class="br0">&#41;</span> <span class="sy0">=</span> f x y : <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith"><span class="kw3">zipWith</span></a>' f xs ys
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="sy0">::</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> b<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>b<span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="sy0">_</span> <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#91;</span><span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> f <span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span> <span class="sy0">=</span> f x : <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> f xs
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="sy0">::</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Bool"><span class="kw4">Bool</span></a><span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="sy0">_</span> <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#91;</span><span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> p <span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span>   
  <span class="sy0">|</span> p x       <span class="sy0">=</span> x : <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> p xs  
  <span class="sy0">|</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:otherwise"><span class="kw3">otherwise</span></a> <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> p xs
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> p l <span class="sy0">==</span> <span class="br0">&#91;</span>x <span class="sy0">|</span> x <span class="sy0">&lt;-</span> l<span class="sy0">,</span> p x<span class="br0">&#93;</span>
&nbsp;
quicksort <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Ord"><span class="kw4">Ord</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span>    
quicksort <span class="br0">&#91;</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#91;</span><span class="br0">&#93;</span>    
quicksort <span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span> <span class="sy0">=</span>     
  <span class="kw1">let</span> smallerSorted <span class="sy0">=</span> quicksort <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="br0">&#40;</span><span class="sy0">&lt;=</span>x<span class="br0">&#41;</span> xs<span class="br0">&#41;</span>  
      biggerSorted <span class="sy0">=</span> quicksort <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="br0">&#40;</span><span class="sy0">&gt;</span>x<span class="br0">&#41;</span> xs<span class="br0">&#41;</span>   
  <span class="kw1">in</span>  smallerSorted <span class="sy0">++</span> <span class="br0">&#91;</span>x<span class="br0">&#93;</span> <span class="sy0">++</span> biggerSorted
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:sum"><span class="kw3">sum</span></a> <span class="br0">&#40;</span>takeWhile <span class="br0">&#40;</span><span class="sy0">&lt;</span>10000<span class="br0">&#41;</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:odd"><span class="kw3">odd</span></a> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span><span class="sy0">^</span><span class="nu0">2</span><span class="br0">&#41;</span> <span class="br0">&#91;</span>1<span class="sy0">..</span><span class="br0">&#93;</span><span class="br0">&#41;</span><span class="br0">&#41;</span><span class="br0">&#41;</span> <span class="co1">--sum of all odd squares that are smaller than 10,000</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith"><span class="kw3">zipWith</span></a> <span class="br0">&#40;</span><span class="sy0">+</span><span class="br0">&#41;</span> l r <span class="sy0">==</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith"><span class="kw3">zipWith</span></a> <span class="br0">&#40;</span>\a b <span class="sy0">-&gt;</span> a <span class="sy0">+</span> b<span class="br0">&#41;</span> l r  <span class="co1">--lamba function</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:sum"><span class="kw3">sum</span></a>' <span class="sy0">::</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Num"><span class="kw4">Num</span></a> a<span class="br0">&#41;</span> <span class="sy0">=&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> a  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:sum"><span class="kw3">sum</span></a>' xs <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:foldl"><span class="kw3">foldl</span></a> <span class="br0">&#40;</span>\acc x <span class="sy0">-&gt;</span> acc <span class="sy0">+</span> x<span class="br0">&#41;</span> 0 xs
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:sum"><span class="kw3">sum</span></a> <span class="sy0">==</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:foldl"><span class="kw3">foldl</span></a> <span class="br0">&#40;</span><span class="sy0">+</span><span class="br0">&#41;</span> 0
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:elem"><span class="kw3">elem</span></a>' y ys <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:foldl"><span class="kw3">foldl</span></a> <span class="br0">&#40;</span>\acc x <span class="sy0">-&gt;</span> acc <span class="sy0">||</span> x <span class="sy0">==</span> y<span class="br0">&#41;</span> False ys
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a>' <span class="sy0">::</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> b<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>b<span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a>' f xs <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:foldr"><span class="kw3">foldr</span></a> <span class="br0">&#40;</span>\x acc <span class="sy0">-&gt;</span> f x : acc<span class="br0">&#41;</span> <span class="br0">&#91;</span><span class="br0">&#93;</span> xs
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a>' <span class="sy0">::</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Bool"><span class="kw4">Bool</span></a><span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span> <span class="sy0">-&gt;</span> <span class="br0">&#91;</span>a<span class="br0">&#93;</span>  
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a>' p <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:foldr"><span class="kw3">foldr</span></a> <span class="br0">&#40;</span>\x acc <span class="sy0">-&gt;</span> <span class="kw1">if</span> p x <span class="kw1">then</span> x : acc <span class="kw1">else</span> acc<span class="br0">&#41;</span> <span class="br0">&#91;</span><span class="br0">&#93;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:scanl"><span class="kw3">scanl</span></a> <span class="br0">&#40;</span><span class="sy0">+</span><span class="br0">&#41;</span> <span class="nu0">0</span> <span class="br0">&#91;</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">5</span><span class="sy0">,</span><span class="nu0">2</span><span class="sy0">,</span><span class="nu0">1</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">0</span><span class="sy0">,</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">8</span><span class="sy0">,</span><span class="nu0">10</span><span class="sy0">,</span><span class="nu0">11</span><span class="br0">&#93;</span>  <span class="co1">--fold that keeps partial results</span>
&nbsp;
<span class="br0">&#40;</span><span class="sy0">$</span><span class="br0">&#41;</span> <span class="sy0">::</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> b<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> a <span class="sy0">-&gt;</span> b  
f <span class="sy0">$</span> x <span class="sy0">=</span> f x                             <span class="co1">--function application function</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span><span class="sy0">$</span> <span class="nu0">3</span><span class="br0">&#41;</span> <span class="br0">&#91;</span><span class="br0">&#40;</span><span class="nu0">4</span><span class="sy0">+</span><span class="br0">&#41;</span><span class="sy0">,</span> <span class="br0">&#40;</span><span class="nu0">10</span><span class="sy0">*</span><span class="br0">&#41;</span><span class="sy0">,</span> <span class="br0">&#40;</span><span class="sy0">^</span><span class="nu0">2</span><span class="br0">&#41;</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">7</span><span class="sy0">,</span> <span class="nu0">30</span><span class="sy0">,</span> <span class="nu0">9</span><span class="br0">&#93;</span> <span class="co1">--mapping function application</span>
&nbsp;
<span class="br0">&#40;</span><span class="sy0">.</span><span class="br0">&#41;</span> <span class="sy0">::</span> <span class="br0">&#40;</span>b <span class="sy0">-&gt;</span> c<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> b<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> a <span class="sy0">-&gt;</span> c  
f <span class="sy0">.</span> g <span class="sy0">=</span> \x <span class="sy0">-&gt;</span> f <span class="br0">&#40;</span>g x<span class="br0">&#41;</span>                       <span class="co1">--function composition function</span>
&nbsp;
<span class="kw1">import</span> Data<span class="sy0">.</span>List                            <span class="co1">--import Data.List module</span>
:m <span class="sy0">+</span> Data<span class="sy0">.</span>List Data<span class="sy0">.</span>Map Data<span class="sy0">.</span>Set            <span class="co1">--import several modules</span>
<span class="kw1">import</span> Data<span class="sy0">.</span>List <span class="br0">&#40;</span>nub<span class="sy0">,</span> sort<span class="br0">&#41;</span>                <span class="co1">--import just nub and sort</span>
<span class="kw1">import</span> Data<span class="sy0">.</span>List <span class="kw1">hiding</span> <span class="br0">&#40;</span>nub<span class="br0">&#41;</span>               <span class="co1">--import all except nub</span>
<span class="kw1">import</span> <span class="kw1">qualified</span> Data<span class="sy0">.</span>Map                   <span class="co1">--force qualification</span>
<span class="kw1">import</span> <span class="kw1">qualified</span> Data<span class="sy0">.</span>Map <span class="kw1">as</span> M              <span class="co1">--force and rename qualification</span>
&nbsp;
<span class="coMULTI">{-
  this is a
  multiline comment
-}</span>
&nbsp;
intersperse <span class="nu0">0</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">0</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">0</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span>
intercalate <span class="st0">&quot; - &quot;</span> <span class="br0">&#91;</span><span class="st0">&quot;hey&quot;</span><span class="sy0">,</span><span class="st0">&quot;there&quot;</span><span class="sy0">,</span><span class="st0">&quot;guys&quot;</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="st0">&quot;hey - there - guys&quot;</span>
transpose <span class="br0">&#91;</span><span class="br0">&#91;</span>1<span class="sy0">,</span>2<span class="sy0">,</span>3<span class="br0">&#93;</span><span class="sy0">,</span><span class="br0">&#91;</span>4<span class="sy0">,</span>5<span class="sy0">,</span>6<span class="br0">&#93;</span><span class="sy0">,</span><span class="br0">&#91;</span>7<span class="sy0">,</span>8<span class="sy0">,</span>9<span class="br0">&#93;</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="br0">&#91;</span>1<span class="sy0">,</span>4<span class="sy0">,</span>7<span class="br0">&#93;</span><span class="sy0">,</span><span class="br0">&#91;</span>2<span class="sy0">,</span>5<span class="sy0">,</span>8<span class="br0">&#93;</span><span class="sy0">,</span><span class="br0">&#91;</span>3<span class="sy0">,</span>6<span class="sy0">,</span>9<span class="br0">&#93;</span><span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:concat"><span class="kw3">concat</span></a> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="br0">&#93;</span> <span class="br0">&#91;</span>3<span class="sy0">,</span> 4<span class="sy0">,</span> 5<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 4<span class="sy0">,</span> 5<span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:concatMap"><span class="kw3">concatMap</span></a>' f <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:concat"><span class="kw3">concat</span></a> <span class="sy0">.</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> f
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:and"><span class="kw3">and</span></a> <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span><span class="sy0">&gt;</span>4<span class="br0">&#41;</span> <span class="br0">&#91;</span>5<span class="sy0">,</span>6<span class="sy0">,</span>7<span class="sy0">,</span>8<span class="br0">&#93;</span> <span class="sy0">==</span> True
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:or"><span class="kw3">or</span></a> <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span><span class="sy0">&gt;</span>4<span class="br0">&#41;</span> <span class="br0">&#91;</span>1<span class="sy0">,</span>2<span class="sy0">,</span>3<span class="br0">&#93;</span> <span class="sy0">==</span> False
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:any"><span class="kw3">any</span></a> <span class="br0">&#40;</span><span class="sy0">==</span>4<span class="br0">&#41;</span> <span class="br0">&#91;</span>2<span class="sy0">,</span>3<span class="sy0">,</span>5<span class="sy0">,</span>6<span class="sy0">,</span>1<span class="sy0">,</span>4<span class="br0">&#93;</span> <span class="sy0">==</span> True
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:all"><span class="kw3">all</span></a> <span class="br0">&#40;</span><span class="sy0">==</span>4<span class="br0">&#41;</span> <span class="br0">&#91;</span>2<span class="sy0">,</span>3<span class="sy0">,</span>5<span class="sy0">,</span>6<span class="sy0">,</span>1<span class="sy0">,</span>4<span class="br0">&#93;</span> <span class="sy0">==</span> False
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:take"><span class="kw3">take</span></a> 4 <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:iterate"><span class="kw3">iterate</span></a> <span class="br0">&#40;</span><span class="sy0">*</span>2<span class="br0">&#41;</span> 1 <span class="sy0">==</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 4<span class="sy0">,</span> 8<span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:splitAt"><span class="kw3">splitAt</span></a> <span class="nu0">3</span> <span class="st0">&quot;abcd&quot;</span> <span class="sy0">==</span> <span class="br0">&#40;</span><span class="st0">&quot;abc&quot;</span><span class="sy0">,</span><span class="st0">&quot;d&quot;</span><span class="br0">&#41;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:dropWhile"><span class="kw3">dropWhile</span></a> <span class="br0">&#40;</span><span class="sy0">&lt;</span>3<span class="br0">&#41;</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 4<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>3<span class="sy0">,</span> 4<span class="br0">&#93;</span>
<span class="br0">&#40;</span>takeWhile p l<span class="br0">&#41;</span> <span class="sy0">++</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:dropWhile"><span class="kw3">dropWhile</span></a> p l<span class="br0">&#41;</span> <span class="sy0">==</span> l
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:span"><span class="kw3">span</span></a> p l <span class="sy0">==</span> <span class="br0">&#40;</span>takeWhile p l<span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:dropWhile"><span class="kw3">dropWhile</span></a> p l<span class="br0">&#41;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:break"><span class="kw3">break</span></a> p <span class="sy0">==</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:span"><span class="kw3">span</span></a> <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:not"><span class="kw3">not</span></a> <span class="sy0">.</span> p
&nbsp;
sort <span class="br0">&#91;</span><span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span>
group <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">2</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">1</span><span class="br0">&#93;</span><span class="sy0">,</span> <span class="br0">&#91;</span><span class="nu0">2</span><span class="br0">&#93;</span><span class="sy0">,</span> <span class="br0">&#91;</span><span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span><span class="sy0">,</span> <span class="br0">&#91;</span><span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">2</span><span class="br0">&#93;</span><span class="br0">&#93;</span> <span class="co1">--group adjacent equals</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span>\l<span class="sy0">@</span><span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#40;</span>x<span class="sy0">,</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:length"><span class="kw3">length</span></a> l<span class="br0">&#41;</span><span class="br0">&#41;</span> <span class="sy0">.</span> group <span class="sy0">.</span> sort <span class="sy0">$</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="br0">&#40;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">3</span><span class="br0">&#41;</span><span class="sy0">,</span> <span class="br0">&#40;</span><span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">1</span><span class="br0">&#41;</span><span class="sy0">,</span> <span class="br0">&#40;</span><span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">1</span><span class="br0">&#41;</span><span class="br0">&#93;</span>  <span class="co1">--occurrences of each element</span>
&nbsp;
inits <span class="st0">&quot;w00t&quot;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="st0">&quot;&quot;</span><span class="sy0">,</span><span class="st0">&quot;w&quot;</span><span class="sy0">,</span><span class="st0">&quot;w0&quot;</span><span class="sy0">,</span><span class="st0">&quot;w00&quot;</span><span class="sy0">,</span><span class="st0">&quot;w00t&quot;</span><span class="br0">&#93;</span>
tails <span class="st0">&quot;w00t&quot;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="st0">&quot;w00t&quot;</span><span class="sy0">,</span><span class="st0">&quot;00t&quot;</span><span class="sy0">,</span><span class="st0">&quot;0t&quot;</span><span class="sy0">,</span><span class="st0">&quot;t&quot;</span><span class="sy0">,</span><span class="st0">&quot;&quot;</span><span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:concat"><span class="kw3">concat</span></a> <span class="sy0">.</span> nub <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span>\<span class="br0">&#40;</span>x<span class="sy0">,</span> y<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> x <span class="sy0">++</span> y<span class="br0">&#41;</span> <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zip"><span class="kw3">zip</span></a> <span class="br0">&#40;</span>inits w<span class="br0">&#41;</span> <span class="br0">&#40;</span>tails w<span class="br0">&#41;</span> <span class="sy0">==</span> w
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:and"><span class="kw3">and</span></a> <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span>`isPrefixOf` w<span class="br0">&#41;</span> <span class="br0">&#40;</span>inits w<span class="br0">&#41;</span> <span class="sy0">==</span> True
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:and"><span class="kw3">and</span></a> <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:map"><span class="kw3">map</span></a> <span class="br0">&#40;</span>`isSuffixOf` w<span class="br0">&#41;</span> <span class="br0">&#40;</span>tails w<span class="br0">&#41;</span> <span class="sy0">==</span> True
<span class="br0">&#91;</span>2<span class="sy0">,</span> 3<span class="br0">&#93;</span> `isInfixOf` <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 4<span class="br0">&#93;</span> <span class="sy0">==</span> True
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:notElem"><span class="kw3">notElem</span></a> x <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:not"><span class="kw3">not</span></a> <span class="sy0">.</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:elem"><span class="kw3">elem</span></a> x
&nbsp;
partition p w <span class="sy0">==</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> p w<span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:not"><span class="kw3">not</span></a> <span class="sy0">.</span> p<span class="br0">&#41;</span> w<span class="br0">&#41;</span>
qsort <span class="br0">&#40;</span>x:xs<span class="br0">&#41;</span> <span class="sy0">=</span> <span class="br0">&#40;</span>qsort <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:fst"><span class="kw3">fst</span></a> p<span class="br0">&#41;</span> <span class="sy0">++</span> <span class="br0">&#91;</span>x<span class="br0">&#93;</span> <span class="sy0">++</span> <span class="br0">&#40;</span>qsort <span class="sy0">$</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:snd"><span class="kw3">snd</span></a> p<span class="br0">&#41;</span>
  <span class="kw1">where</span> p <span class="sy0">=</span> partition <span class="br0">&#40;</span><span class="sy0">&lt;=</span>x<span class="br0">&#41;</span> xs
&nbsp;
find <span class="br0">&#40;</span><span class="sy0">&gt;</span><span class="nu0">2</span><span class="br0">&#41;</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">4</span><span class="br0">&#93;</span> <span class="sy0">==</span> Just <span class="nu0">3</span>
find <span class="br0">&#40;</span><span class="sy0">&gt;</span><span class="nu0">4</span><span class="br0">&#41;</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span> <span class="nu0">2</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="nu0">4</span><span class="br0">&#93;</span> <span class="sy0">==</span> Nothing
'b' `elemIndex` <span class="st0">&quot;abc&quot;</span> <span class="sy0">==</span> Just <span class="nu0">1</span>
'a' `elemIndices` <span class="st0">&quot;abac&quot;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>0<span class="sy0">,</span> 2<span class="br0">&#93;</span>
findIndex <span class="br0">&#40;</span><span class="sy0">&gt;</span>2<span class="br0">&#41;</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 4<span class="br0">&#93;</span> <span class="sy0">==</span> Just 2
findIndices <span class="br0">&#40;</span><span class="sy0">&gt;</span>2<span class="br0">&#41;</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 4<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>2<span class="sy0">,</span> 3<span class="br0">&#93;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:zipWith3"><span class="kw3">zipWith3</span></a> <span class="br0">&#40;</span>\x y z <span class="sy0">-&gt;</span> x <span class="sy0">+</span> y <span class="sy0">+</span> z<span class="br0">&#41;</span> <span class="br0">&#91;</span>1<span class="sy0">,</span>2<span class="sy0">,</span>3<span class="br0">&#93;</span> <span class="br0">&#91;</span>4<span class="sy0">,</span>5<span class="sy0">,</span>2<span class="sy0">,</span>2<span class="br0">&#93;</span> <span class="br0">&#91;</span>2<span class="sy0">,</span>2<span class="sy0">,</span>3<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>7<span class="sy0">,</span>9<span class="sy0">,</span>8<span class="br0">&#93;</span>  
zip4 <span class="br0">&#91;</span>2<span class="sy0">,</span>3<span class="sy0">,</span>3<span class="br0">&#93;</span> <span class="br0">&#91;</span>2<span class="sy0">,</span>2<span class="sy0">,</span>2<span class="br0">&#93;</span> <span class="br0">&#91;</span>5<span class="sy0">,</span>5<span class="sy0">,</span>3<span class="br0">&#93;</span> <span class="br0">&#91;</span>2<span class="sy0">,</span>2<span class="sy0">,</span>2<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="br0">&#40;</span>2<span class="sy0">,</span>2<span class="sy0">,</span>5<span class="sy0">,</span>2<span class="br0">&#41;</span><span class="sy0">,</span><span class="br0">&#40;</span>3<span class="sy0">,</span>2<span class="sy0">,</span>5<span class="sy0">,</span>2<span class="br0">&#41;</span><span class="sy0">,</span><span class="br0">&#40;</span>3<span class="sy0">,</span>2<span class="sy0">,</span>3<span class="sy0">,</span>2<span class="br0">&#41;</span><span class="br0">&#93;</span>
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:lines"><span class="kw3">lines</span></a> <span class="st0">&quot;first line<span class="es0">\n</span>second line<span class="es0">\n</span>third line&quot;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="st0">&quot;first line&quot;</span><span class="sy0">,</span><span class="st0">&quot;second line&quot;</span><span class="sy0">,</span><span class="st0">&quot;third line&quot;</span><span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:unlines"><span class="kw3">unlines</span></a> <span class="br0">&#91;</span><span class="st0">&quot;first line&quot;</span><span class="sy0">,</span> <span class="st0">&quot;second line&quot;</span><span class="sy0">,</span> <span class="st0">&quot;third line&quot;</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="st0">&quot;first line<span class="es0">\n</span>second line<span class="es0">\n</span>third line<span class="es0">\n</span>&quot;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:words"><span class="kw3">words</span></a> <span class="st0">&quot;hey<span class="es0">\n</span>there           mate&quot;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="st0">&quot;hey&quot;</span><span class="sy0">,</span><span class="st0">&quot;there&quot;</span><span class="sy0">,</span><span class="st0">&quot;mate&quot;</span><span class="br0">&#93;</span>
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:unwords"><span class="kw3">unwords</span></a> <span class="br0">&#91;</span><span class="st0">&quot;hey&quot;</span><span class="sy0">,</span><span class="st0">&quot;there&quot;</span><span class="sy0">,</span><span class="st0">&quot;mate&quot;</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="st0">&quot;hey there mate&quot;</span>
&nbsp;
nub <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span><span class="nu0">2</span><span class="sy0">,</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">4</span><span class="sy0">,</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">2</span><span class="sy0">,</span><span class="nu0">1</span><span class="sy0">,</span><span class="nu0">2</span><span class="sy0">,</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">4</span><span class="sy0">,</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">2</span><span class="sy0">,</span><span class="nu0">1</span><span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span><span class="nu0">1</span><span class="sy0">,</span><span class="nu0">2</span><span class="sy0">,</span><span class="nu0">3</span><span class="sy0">,</span><span class="nu0">4</span><span class="br0">&#93;</span> <span class="co1">--erase duplicates</span>
delete 'b' <span class="st0">&quot;abcbc&quot;</span> <span class="sy0">==</span> <span class="st0">&quot;acbc&quot;</span>                 <span class="co1">--erase first occurence</span>
&nbsp;
<span class="br0">&#40;</span>l \\ r<span class="br0">&#41;</span> <span class="sy0">==</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="br0">&#40;</span>`<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:notElem"><span class="kw3">notElem</span></a>` r<span class="br0">&#41;</span> l<span class="br0">&#41;</span>
union <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 2<span class="br0">&#93;</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span>
intersect <span class="br0">&#91;</span>0<span class="sy0">,</span> 1<span class="sy0">,</span> 2<span class="sy0">,</span> 2<span class="br0">&#93;</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 2<span class="br0">&#93;</span>
insert 2 <span class="br0">&#91;</span>1<span class="sy0">,</span> 3<span class="sy0">,</span> 1<span class="sy0">,</span> 2<span class="br0">&#93;</span> <span class="sy0">==</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="sy0">,</span> 3<span class="sy0">,</span> 1<span class="sy0">,</span> 2<span class="br0">&#93;</span>
&nbsp;
genericLength<span class="sy0">,</span> genericTake<span class="sy0">,</span> genericDrop<span class="sy0">,</span> genericSplitAt<span class="sy0">,</span> genericIndex <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:and"><span class="kw3">and</span></a> genericReplicate
average xs <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:sum"><span class="kw3">sum</span></a> xs <span class="sy0">/</span> genericLength xs
&nbsp;
nubBy<span class="sy0">,</span> deleteBy<span class="sy0">,</span> unionBy<span class="sy0">,</span> intersectBy <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:and"><span class="kw3">and</span></a> groupBy
group <span class="sy0">=</span> groupBy <span class="br0">&#40;</span><span class="sy0">==</span><span class="br0">&#41;</span>
&nbsp;
on <span class="sy0">::</span> <span class="br0">&#40;</span>b <span class="sy0">-&gt;</span> b <span class="sy0">-&gt;</span> c<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> <span class="br0">&#40;</span>a <span class="sy0">-&gt;</span> b<span class="br0">&#41;</span> <span class="sy0">-&gt;</span> a <span class="sy0">-&gt;</span> a <span class="sy0">-&gt;</span> c  
f `on` g <span class="sy0">=</span> \x y <span class="sy0">-&gt;</span> f <span class="br0">&#40;</span>g x<span class="br0">&#41;</span> <span class="br0">&#40;</span>g y<span class="br0">&#41;</span>
&nbsp;
sortBy<span class="sy0">,</span> insertBy<span class="sy0">,</span> maximumBy <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:and"><span class="kw3">and</span></a> minimumBy
sort <span class="sy0">=</span> sortBy <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:compare"><span class="kw3">compare</span></a>
sortBy <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:compare"><span class="kw3">compare</span></a> `on` <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:length"><span class="kw3">length</span></a><span class="br0">&#41;</span> <span class="br0">&#91;</span><span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="br0">&#93;</span><span class="sy0">,</span> <span class="br0">&#91;</span><span class="br0">&#93;</span><span class="sy0">,</span> <span class="br0">&#91;</span>3<span class="br0">&#93;</span><span class="br0">&#93;</span>  <span class="sy0">==</span> <span class="br0">&#91;</span><span class="br0">&#91;</span><span class="br0">&#93;</span><span class="sy0">,</span> <span class="br0">&#91;</span>3<span class="br0">&#93;</span><span class="sy0">,</span> <span class="br0">&#91;</span>1<span class="sy0">,</span> 2<span class="br0">&#93;</span><span class="br0">&#93;</span>
&nbsp;
isControl<span class="sy0">,</span> isSpace<span class="sy0">,</span> isLower<span class="sy0">,</span> isUpper<span class="sy0">,</span> isAlpha<span class="sy0">,</span> isAlphaNum<span class="sy0">,</span>
isPrint<span class="sy0">,</span> isDigit<span class="sy0">,</span> isOctDigit<span class="sy0">,</span> isHexDigit<span class="sy0">,</span> isLetter<span class="sy0">,</span> isMark<span class="sy0">,</span>
isNumber<span class="sy0">,</span> isPunctuation<span class="sy0">,</span> isSymbol<span class="sy0">,</span> isSeparator<span class="sy0">,</span> isAscii<span class="sy0">,</span>
isLatin1<span class="sy0">,</span> isAsciiUpper<span class="sy0">,</span> isAsciiLower
&nbsp;
<a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:not"><span class="kw3">not</span></a> <span class="sy0">.</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:any"><span class="kw3">any</span></a> isSpace<span class="br0">&#41;</span> <span class="sy0">.</span> groupBy <span class="br0">&#40;</span><span class="br0">&#40;</span><span class="sy0">==</span><span class="br0">&#41;</span> `on` isSpace<span class="br0">&#41;</span> <span class="sy0">$</span> w <span class="sy0">==</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:words"><span class="kw3">words</span></a> w
&nbsp;
toUpper<span class="sy0">,</span> toLower<span class="sy0">,</span> toTitle<span class="sy0">,</span> digitToInt<span class="sy0">,</span> intToDigit<span class="sy0">,</span> ord<span class="sy0">,</span> chr</pre>
<pre class="code haskell"><span class="kw1">module</span> Shapes   
<span class="br0">&#40;</span> Shape<span class="br0">&#40;</span><span class="sy0">..</span><span class="br0">&#41;</span>  
<span class="sy0">,</span> surface
<span class="br0">&#41;</span> <span class="kw1">where</span>
&nbsp;
<span class="kw1">data</span> Shape <span class="sy0">=</span> Circle <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <span class="sy0">|</span> Rectangle <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a>
<span class="kw1">data</span> Shape <span class="sy0">=</span> Circle <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <span class="sy0">|</span> Rectangle <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a> <span class="kw1">deriving</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Show"><span class="kw4">Show</span></a><span class="br0">&#41;</span>
&nbsp;
surface <span class="sy0">::</span> Shape <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a>  
surface <span class="br0">&#40;</span>Circle <span class="sy0">_</span> <span class="sy0">_</span> r<span class="br0">&#41;</span> <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:pi"><span class="kw3">pi</span></a> <span class="sy0">*</span> r <span class="sy0">^</span> 2  
surface <span class="br0">&#40;</span>Rectangle x1 y1 x2 y2<span class="br0">&#41;</span> <span class="sy0">=</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:abs"><span class="kw3">abs</span></a> <span class="sy0">$</span> x2 <span class="sy0">-</span> x1<span class="br0">&#41;</span> <span class="sy0">*</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:abs"><span class="kw3">abs</span></a> <span class="sy0">$</span> y2 <span class="sy0">-</span> y1<span class="br0">&#41;</span></pre>
<pre class="code haskell"><span class="kw1">data</span> Person <span class="sy0">=</span> Person <span class="br0">&#123;</span> firstName <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a>  
                     <span class="sy0">,</span> lastName <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a>  
                     <span class="sy0">,</span> age <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Int"><span class="kw4">Int</span></a>  
                     <span class="sy0">,</span> height <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Float"><span class="kw4">Float</span></a>  
                     <span class="sy0">,</span> phoneNumber <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a>  
                     <span class="sy0">,</span> flavor <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a>  
                     <span class="br0">&#125;</span> <span class="kw1">deriving</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Show"><span class="kw4">Show</span></a><span class="br0">&#41;</span>
&nbsp;
<span class="kw1">data</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Maybe"><span class="kw4">Maybe</span></a> a <span class="sy0">=</span> Nothing <span class="sy0">|</span> Just a
<span class="kw1">data</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Either"><span class="kw4">Either</span></a> a b <span class="sy0">=</span> Left a <span class="sy0">|</span> Right b <span class="kw1">deriving</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Eq"><span class="kw4">Eq</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Ord"><span class="kw4">Ord</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Read"><span class="kw4">Read</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Show"><span class="kw4">Show</span></a><span class="br0">&#41;</span>
<span class="kw1">data</span> List a <span class="sy0">=</span> Empty <span class="sy0">|</span> Cons a <span class="br0">&#40;</span>List a<span class="br0">&#41;</span> <span class="kw1">deriving</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Show"><span class="kw4">Show</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Read"><span class="kw4">Read</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Eq"><span class="kw4">Eq</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Ord"><span class="kw4">Ord</span></a><span class="br0">&#41;</span>  
<span class="kw1">infixr</span> 5 :<span class="sy0">-</span>:
<span class="kw1">data</span> List a <span class="sy0">=</span> Empty <span class="sy0">|</span> a :<span class="sy0">-</span>: <span class="br0">&#40;</span>List a<span class="br0">&#41;</span> <span class="kw1">deriving</span> <span class="br0">&#40;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Show"><span class="kw4">Show</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Read"><span class="kw4">Read</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Eq"><span class="kw4">Eq</span></a><span class="sy0">,</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Ord"><span class="kw4">Ord</span></a><span class="br0">&#41;</span>
&nbsp;
<span class="kw1">type</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a> <span class="sy0">=</span> <span class="br0">&#91;</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Char"><span class="kw4">Char</span></a><span class="br0">&#93;</span> <span class="co1">--type synonym</span></pre>
<pre class="code haskell"><span class="kw1">import</span> Control<span class="sy0">.</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Monad"><span class="kw4">Monad</span></a>   
&nbsp;
main <span class="sy0">=</span> <span class="kw1">do</span>  
  c <span class="sy0">&lt;-</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:getChar"><span class="kw3">getChar</span></a>  
  when <span class="br0">&#40;</span>c <span class="sy0">/=</span> ' '<span class="br0">&#41;</span> <span class="sy0">$</span> <span class="kw1">do</span>  
    <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putChar"><span class="kw3">putChar</span></a> c  
    main</pre>
<pre class="code haskell">main <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:interact"><span class="kw3">interact</span></a> shortLinesOnly  
&nbsp;
shortLinesOnly <span class="sy0">::</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a> <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:String"><span class="kw4">String</span></a>  
shortLinesOnly input <span class="sy0">=</span>   
  <span class="kw1">let</span> allLines <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:lines"><span class="kw3">lines</span></a> input  
      shortLines <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:filter"><span class="kw3">filter</span></a> <span class="br0">&#40;</span>\line <span class="sy0">-&gt;</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:length"><span class="kw3">length</span></a> line <span class="sy0">&lt;</span> 10<span class="br0">&#41;</span> allLines  
      result <span class="sy0">=</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:unlines"><span class="kw3">unlines</span></a> shortLines  
  <span class="kw1">in</span>  result</pre>
<pre class="code haskell"><span class="kw1">import</span> System<span class="sy0">.</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:IO"><span class="kw4">IO</span></a>     
&nbsp;
main <span class="sy0">=</span> <span class="kw1">do</span>     
  withFile <span class="st0">&quot;girlfriend.txt&quot;</span> ReadMode <span class="br0">&#40;</span>\handle <span class="sy0">-&gt;</span> <span class="kw1">do</span>  
    contents <span class="sy0">&lt;-</span> hGetContents handle     
    <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStr"><span class="kw3">putStr</span></a> contents<span class="br0">&#41;</span></pre>
<pre class="code haskell"><span class="kw1">import</span> System<span class="sy0">.</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:IO"><span class="kw4">IO</span></a>  
&nbsp;
main <span class="sy0">=</span> <span class="kw1">do</span>  
  contents <span class="sy0">&lt;-</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:readFile"><span class="kw3">readFile</span></a> <span class="st0">&quot;girlfriend.txt&quot;</span>  
  <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStr"><span class="kw3">putStr</span></a> contents</pre>
<pre class="code haskell"><span class="kw1">import</span> System<span class="sy0">.</span>Environment   
<span class="kw1">import</span> Data<span class="sy0">.</span>List  
&nbsp;
main <span class="sy0">=</span> <span class="kw1">do</span>  
  args <span class="sy0">&lt;-</span> getArgs  
  progName <span class="sy0">&lt;-</span> getProgName  
  <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStrLn"><span class="kw3">putStrLn</span></a> <span class="st0">&quot;The arguments are:&quot;</span>  
  <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:mapM"><span class="kw3">mapM</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStrLn"><span class="kw3">putStrLn</span></a> args  
  <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStrLn"><span class="kw3">putStrLn</span></a> <span class="st0">&quot;The program name is:&quot;</span>  
  <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStrLn"><span class="kw3">putStrLn</span></a> progName</pre>
<pre class="code haskell"><span class="kw1">import</span> Control<span class="sy0">.</span><a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#t:Monad"><span class="kw4">Monad</span></a>  
&nbsp;
main <span class="sy0">=</span> <span class="kw1">do</span>   
  colors <span class="sy0">&lt;-</span> forM <span class="br0">&#91;</span>1<span class="sy0">,</span>2<span class="sy0">,</span>3<span class="sy0">,</span>4<span class="br0">&#93;</span> <span class="br0">&#40;</span>\a <span class="sy0">-&gt;</span> <span class="kw1">do</span>  
    <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStrLn"><span class="kw3">putStrLn</span></a> <span class="sy0">$</span> <span class="st0">&quot;Which color do you associate with the number &quot;</span> <span class="sy0">++</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:show"><span class="kw3">show</span></a> a <span class="sy0">++</span> <span class="st0">&quot;?&quot;</span>  
    color <span class="sy0">&lt;-</span> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:getLine"><span class="kw3">getLine</span></a>  
    <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:return"><span class="kw3">return</span></a> color<span class="br0">&#41;</span>  
  <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStrLn"><span class="kw3">putStrLn</span></a> <span class="st0">&quot;The colors that you associate with 1, 2, 3 and 4 are: &quot;</span>  
  <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:mapM"><span class="kw3">mapM</span></a> <a href="http://haskell.org/ghc/docs/latest/html/libraries/base/Prelude.html#v:putStrLn"><span class="kw3">putStrLn</span></a> colors</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Haskell Cheat Sheet" [637-] -->